<?php

namespace Drupal\proc\Controller;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Controller\ControllerBase;

/**
 * Controller.
 */
class ProcController extends ControllerBase {

  /**
   * Demonstrates use of optional URL arguments in for menu item.
   *
   * @param string $user
   *   First argument of URL.
   *
   * @return array
   *   Controller response.
   */
  public function checkRecipient($user) {
    // Check if this user holds PGP keys:
    $key_id = false;
    $query = \Drupal::entityQuery('proc')
      ->accessCheck(TRUE)
      ->condition('user_id', $user)
      ->condition('type', 'keyring')
      ->sort('id', 'DESC')
      ->range(0, 1);
    $key_id = key($query->execute());
    if (!$key_id) {
      return AccessResult::forbidden('User account does not exist or user is not a holder of PGP keys.');
    }
    return AccessResult::allowed();
  }


}
